* Check price questionnaire and merge it with information (budget shares and psu prices) from the household questionnaire
*Next line changed to Cl1 (from cl2) to conform with changes in cleaning

use data\price_list_cl1, clear
recode m11_q03 9999=.
recode m11_q04 9999=.
recode m11_q05 9999=.
egen comprice=rmean(m11_q03 m11_q04 m11_q05)

* a number of items for which we have information on prices are grouped together in the household questionnaire in item 13 of sect11, we check which one is better to use
count if comprice!=. & m11_q00==54
count if comprice!=. & m11_q00==55
tab comprice if m11_q00==54
tab comprice if m11_q00==55
* beer or raki?

* a number of items for which we have information on prices are grouped together in the household questionnaire in item 3 of sect11, we check which one is better to use
count if comprice!=. & m11_q00==69
count if comprice!=. & m11_q00==70
count if comprice!=. & m11_q00==71
count if comprice!=. & m11_q00==73
count if comprice!=. & m11_q00==74
count if comprice!=. & m11_q00==76
count if comprice!=. & m11_q00==80
tab comprice if m11_q00==76
tab comprice if m11_q00==80
tab comprice if m11_q00==71
* soap, matches or candles

* a number of items for which we have information on prices are grouped together in the household questionnaire in item 1 of sect11, we check which one is better to use
count if comprice!=. & m11_q00==75
count if comprice!=. & m11_q00==77
count if comprice!=. & m11_q00==78
count if comprice!=. & m11_q00==79
tab comprice if m11_q00==75
tab comprice if m11_q00==77
* toilet soap or toothpaste

* now we can match codes of items in community and household questionnaire 

*** Food items

gen itc=12 if m11_q00==1
replace itc=1 if m11_q00==2
replace itc=15 if m11_q00==3
replace itc=13 if m11_q00==4
replace itc=27 if m11_q00==5
replace itc=34 if m11_q00==6
replace itc=31 if m11_q00==7
replace itc=37 if m11_q00==8
replace itc=40 if m11_q00==9
replace itc=52 if m11_q00==10
replace itc=54 if m11_q00==11
replace itc=65 if m11_q00==12
replace itc=74 if m11_q00==13
replace itc=69 if m11_q00==14
replace itc=7 if m11_q00==15
replace itc=78 if m11_q00==16
replace itc=76 if m11_q00==17
replace itc=87 if m11_q00==18
replace itc=85 if m11_q00==19
replace itc=84 if m11_q00==20
replace itc=92 if m11_q00==21
replace itc=112 if m11_q00==22
replace itc=91 if m11_q00==23
replace itc=93 if m11_q00==24
replace itc=94 if m11_q00==25
replace itc=96 if m11_q00==26
replace itc=136 if m11_q00==27
replace itc=139 if m11_q00==28
replace itc=131 if m11_q00==29
replace itc=125 if m11_q00==30
replace itc=126 if m11_q00==31
replace itc=127 if m11_q00==32
replace itc=128 if m11_q00==33
replace itc=129 if m11_q00==34
replace itc=137 if m11_q00==35
replace itc=138 if m11_q00==36
replace itc=143 if m11_q00==37
replace itc=130 if m11_q00==38
replace itc=146 if m11_q00==39
replace itc=141 if m11_q00==40
replace itc=151 if m11_q00==41
replace itc=148 if m11_q00==42
replace itc=170 if m11_q00==43
replace itc=171 if m11_q00==44
replace itc=156 if m11_q00==45
replace itc=175 if m11_q00==46
replace itc=176 if m11_q00==47
replace itc=189 if m11_q00==48
replace itc=217 if m11_q00==49
replace itc=218 if m11_q00==50
replace itc=222 if m11_q00==51
replace itc=225 if m11_q00==52
replace itc=223 if m11_q00==53

*** there are other items that can be used for the price index:
* 1) cigarettes (56) for item 12 of sect11a 'cigarettes, tobacco, cigars'
* 2) beer (54) for item 13 of sect11a 'Alcohol, beer, wine, etc'
* 3) soap for cloth washing (76) or matches (80) or candles (71) for item 3 of sect11a 'Household supplies and cleaning products'
* 4) toilet soap (75) or toothpaste (77) for item 1 in sect11a 'Cosmetics and personal care products'

replace itc=303 if m11_q00==54
replace itc=302 if m11_q00==56
replace itc=300 if m11_q00==75
replace itc=301 if m11_q00==76
replace itc=304 if m11_q00==80
replace itc=305 if m11_q00==71
replace itc=306 if m11_q00==77

drop if itc==.
sort quest_num itc
save temp, replace
* we need to add cases for the quest_num 21 which is missing
gen one=1
collapse (sum) one, by(itc)
table itc, c(m one)
gen quest_num=21
drop one
sort quest_num itc
merge quest_num itc using temp
tab _merge
keep ur_area quest_num comprice itc
table itc, c(n comprice)
* for some items we do not have all the needed information, not all the community questionnaire reported prices for all the items
sort quest_num
merge quest_num using results\basecom
tab _merge
keep if _merge==3
drop _merge
count if comprice!=.
count if comprice==.
egen medprice1=median(comprice), by(district urbrur itc)
egen medprice2=median(comprice), by(prefect urbrur itc)
egen medprice3=median(comprice), by(stratum urbrur itc)
gen comprice1=comprice
replace comprice1=medprice1 if comprice1==.
replace comprice1=medprice2 if comprice1==.
replace comprice1=medprice3 if comprice1==.
count if comprice1==.
sort quest_num itc
save results\comprices, replace

tab urbrur ur_area
tab quest_num if urbrur==2 & ur_area==1
tab quest_num if urbrur==1 & ur_area==2

clear
set mem 30m

use results\nfood1, clear
gen exp=nfood1 if code==1 
replace exp=nfood1 if code==3
replace exp=nfood1 if code==13
replace exp=nfood1 if code==12

*****************************************************************************
*** here we can make the choice of which price goes with which aggregate  ***
*****************************************************************************

gen itc=300 if code==1
*gen itc=306 if code==1
*replace itc=304 if code==3
replace itc=301 if code==3
replace itc=302 if code==12
replace itc=303 if code==13
keep if itc!=.
keep hhid itc exp
* we convert this expenditure in period of refernce of half a month
replace exp=exp/2.17
sort hhid
merge hhid using results\base
tab _merge
drop if _merge==2
drop _merge day
sort hhid itc
save temp, replace

use results\prices, clear
sort hhid itc
merge hhid itc using temp
tab _merge
drop _merge
label def itc 300 "toilet soap", add
label def itc 301 "washing soap", add
label def itc 302 "cigarettes", add
label def itc 303 "beer", add
label def itc 304 "matches", add
label def itc 306 "toothpaste", add
lab val itc itc
replace exp=foodexp if exp==.
drop foodexp

* apply syntax to create the same identifier of the price questionnaire

gen quest_num = 1 if psu == 12                      
replace quest_num = 2 if psu == 10                      
replace quest_num = 3 if psu == 3                      
replace quest_num = 4 if psu == 1                      
replace quest_num = 5 if psu == 2                      
replace quest_num = 6 if psu == 8                      
replace quest_num = 7 if psu == 6                      
replace quest_num = 8 if psu == 9                      
replace quest_num = 9 if psu == 7                      
replace quest_num = 10 if psu == 11                      
replace quest_num = 11 if psu == 21                      
replace quest_num = 12 if psu == 15 |  psu== 17 |  psu== 20                  
replace quest_num = 13 if psu == 18 |  psu== 19 |  psu== 23                  
replace quest_num = 14 if psu == 16 |  psu== 22 |  psu== 24                  
replace quest_num = 15 if psu == 14                      
replace quest_num = 16 if psu == 5                      
replace quest_num = 17 if psu == 13                      
replace quest_num = 18 if psu == 33                      
replace quest_num = 19 if psu == 34                      
replace quest_num = 20 if psu == 37 |  psu== 38 |  psu== 39 |  psu== 40 |  psu== 41  
replace quest_num = 21 if psu == 4        
replace quest_num = 22 if psu == 32                      
replace quest_num = 23 if psu == 31                      
replace quest_num = 24 if psu == 29                      
replace quest_num = 25 if psu == 30                      
replace quest_num = 26 if psu == 35 |  psu== 36                    
replace quest_num = 27 if psu == 27                      
replace quest_num = 28 if psu == 25                      
replace quest_num = 29 if psu == 26                      
replace quest_num = 30 if psu == 42                      
replace quest_num = 31 if psu == 43                      
replace quest_num = 32 if psu == 44                      
replace quest_num = 33 if psu == 45                      
replace quest_num = 34 if psu == 46                      
replace quest_num = 35 if psu == 47                      
replace quest_num = 36 if psu == 48                      
replace quest_num = 37 if psu == 49                      
replace quest_num = 38 if psu == 50                      
replace quest_num = 39 if psu == 51                      
replace quest_num = 40 if psu == 52                      
replace quest_num = 41 if psu == 53                      
replace quest_num = 42 if psu == 54                      
replace quest_num = 43 if psu == 55 |  psu== 56 |  psu== 57 |  psu== 58 |  psu== 59 |  psu== 60 |  psu== 61 |  psu== 62 |  psu== 63 |  psu== 64    
replace quest_num = 44 if psu == 28                      
replace quest_num = 45 if psu == 65                      
replace quest_num = 46 if psu == 67                      
replace quest_num = 47 if psu == 68                      
replace quest_num = 48 if psu == 69                      
replace quest_num = 49 if psu == 71                      
replace quest_num = 50 if psu == 72                      
replace quest_num = 51 if psu == 73                      
replace quest_num = 52 if psu == 74                      
replace quest_num = 53 if psu == 78 |  psu== 75 |  psu== 76                  
replace quest_num = 54 if psu == 79 |  psu== 80                    
replace quest_num = 55 if psu == 82                      
replace quest_num = 56 if psu == 66                      
replace quest_num = 57 if psu == 81                      
replace quest_num = 58 if psu == 70                      
replace quest_num = 59 if psu == 77                      
replace quest_num = 60 if psu == 83                      
replace quest_num = 61 if psu == 84                      
replace quest_num = 62 if psu == 85                      
replace quest_num = 63 if psu == 86                      
replace quest_num = 64 if psu == 87                      
replace quest_num = 65 if psu == 88                      
replace quest_num = 66 if psu == 89                      
replace quest_num = 67 if psu == 90                      
replace quest_num = 68 if psu == 91                      
replace quest_num = 69 if psu == 92                      
replace quest_num = 70 if psu == 93                      
replace quest_num = 71 if psu == 94                      
replace quest_num = 72 if psu == 95                      
replace quest_num = 73 if psu == 96                      
replace quest_num = 74 if psu == 97                      
replace quest_num = 75 if psu == 98                      
replace quest_num = 76 if psu == 99                      
replace quest_num = 77 if psu == 100                      
replace quest_num = 78 if psu == 101                      
replace quest_num = 79 if psu == 102 |  psu== 103 |  psu== 104 |  psu== 105 |  psu== 106 |  psu== 107 |  psu== 108 |  psu== 109 |  psu== 110 |  psu== 111    
replace quest_num = 80 if psu == 114                      
replace quest_num = 81 if psu == 113                      
replace quest_num = 82 if psu == 123                      
replace quest_num = 83 if psu == 112                      
replace quest_num = 84 if psu == 115                      
replace quest_num = 85 if psu == 116                      
replace quest_num = 86 if psu == 117                      
replace quest_num = 87 if psu == 118                      
replace quest_num = 88 if psu == 119                      
replace quest_num = 89 if psu == 120                      
replace quest_num = 90 if psu == 121                      
replace quest_num = 91 if psu == 122                      
replace quest_num = 92 if psu == 124                      
replace quest_num = 93 if psu == 125                      
replace quest_num = 94 if psu == 126                      
replace quest_num = 95 if psu == 127 |  psu== 128                    
replace quest_num = 96 if psu == 129                      
replace quest_num = 97 if psu == 130                      
replace quest_num = 98 if psu == 131 |  psu== 132 |  psu== 133 |  psu== 136                
replace quest_num = 99 if psu == 134 |  psu== 135                    
replace quest_num = 100 if psu == 140                      
replace quest_num = 101 if psu == 143                      
replace quest_num = 102 if psu == 141                      
replace quest_num = 103 if psu == 139                      
replace quest_num = 104 if psu == 145                      
replace quest_num = 105 if psu == 144                      
replace quest_num = 106 if psu == 142                      
replace quest_num = 107 if psu == 150 |  psu== 151 |  psu== 152 |  psu== 153 |  psu== 154 |  psu== 155 |  psu== 156          
replace quest_num = 108 if psu == 138                      
replace quest_num = 109 if psu == 137                      
replace quest_num = 110 if psu == 148                      
replace quest_num = 111 if psu == 147                      
replace quest_num = 112 if psu == 146                      
replace quest_num = 113 if psu == 149                      
replace quest_num = 114 if psu == 168                      
replace quest_num = 115 if psu == 169                      
replace quest_num = 116 if psu == 167                      
replace quest_num = 117 if psu == 166                      
replace quest_num = 118 if psu == 165                      
replace quest_num = 119 if psu == 164                      
replace quest_num = 120 if psu == 163                      
replace quest_num = 121 if psu == 161                      
replace quest_num = 122 if psu == 162                      
replace quest_num = 123 if psu == 160                      
replace quest_num = 124 if psu == 170                      
replace quest_num = 125 if psu == 159                      
replace quest_num = 126 if psu == 158                      
replace quest_num = 127 if psu == 157                      
replace quest_num = 128 if psu == 171                      
replace quest_num = 129 if psu == 172                      
replace quest_num = 130 if psu == 173                      
replace quest_num = 131 if psu == 179 |  psu== 180 |  psu== 181                  
replace quest_num = 132 if psu == 174 |  psu== 175 |  psu== 176 |  psu== 177 |  psu== 178              
replace quest_num = 133 if psu == 182                      
replace quest_num = 134 if psu == 183                      
replace quest_num = 135 if psu == 184                      
replace quest_num = 136 if psu == 185                      
replace quest_num = 137 if psu == 186                      
replace quest_num = 138 if psu == 187                      
replace quest_num = 139 if psu == 188                      
replace quest_num = 140 if psu == 189                      
replace quest_num = 141 if psu == 190                      
replace quest_num = 142 if psu == 191                      
replace quest_num = 144 if psu == 196 |  psu== 200                    
replace quest_num = 145 if psu == 195 |  psu== 201 |  psu== 194                  
replace quest_num = 146 if psu == 198 |  psu== 199                    
replace quest_num = 147 if psu == 197 |  psu== 202 |  psu== 203 |  psu== 192                
replace quest_num = 148 if psu == 204                      
replace quest_num = 149 if psu == 205                      
replace quest_num = 150 if psu == 206                      
replace quest_num = 151 if psu == 217 |  psu== 218 |  psu== 220 |  psu== 222                
replace quest_num = 152 if psu == 207                      
replace quest_num = 153 if psu == 208                      
replace quest_num = 154 if psu == 209                      
replace quest_num = 155 if psu == 210                      
replace quest_num = 156 if psu == 211                      
replace quest_num = 157 if psu == 212                      
replace quest_num = 158 if psu == 213                      
replace quest_num = 159 if psu == 214                      
replace quest_num = 160 if psu == 215                      
replace quest_num = 161 if psu == 216                      
replace quest_num = 162 if psu == 219 |  psu== 221                    
replace quest_num = 163 if psu == 230 |  psu== 231 |  psu== 232 |  psu== 233 |  psu== 234 |  psu== 235 |  psu== 236 |  psu== 237        
replace quest_num = 164 if psu == 223                      
replace quest_num = 165 if psu == 228                      
replace quest_num = 166 if psu == 226                      
replace quest_num = 167 if psu == 227                      
replace quest_num = 168 if psu == 225                      
replace quest_num = 169 if psu == 229                      
replace quest_num = 170 if psu == 224                      
replace quest_num = 171 if psu == 260 |  psu== 262 |  psu== 265 |  psu== 268                
replace quest_num = 172 if psu == 264 |  psu== 267                    
replace quest_num = 173 if psu == 248                      
replace quest_num = 174 if psu == 263 |  psu== 261 |  psu== 269                  
replace quest_num = 175 if psu == 266                      
replace quest_num = 176 if psu == 245                      
replace quest_num = 177 if psu == 238                      
replace quest_num = 178 if psu == 239                      
replace quest_num = 179 if psu == 240                      
replace quest_num = 180 if psu == 241                      
replace quest_num = 181 if psu == 242                      
replace quest_num = 182 if psu == 243                      
replace quest_num = 183 if psu == 244                      
replace quest_num = 184 if psu == 246                      
replace quest_num = 185 if psu == 247                      
replace quest_num = 186 if psu == 249                      
replace quest_num = 187 if psu == 250                      
replace quest_num = 188 if psu == 251                      
replace quest_num = 189 if psu == 252                      
replace quest_num = 190 if psu == 253                      
replace quest_num = 191 if psu == 254                      
replace quest_num = 192 if psu == 255 |  psu== 256 |  psu== 257                  
replace quest_num = 193 if psu == 258                      
replace quest_num = 194 if psu == 259                      
replace quest_num = 195 if psu == 288 |  psu== 289                    
replace quest_num = 196 if psu == 281 |  psu== 282 |  psu== 283 |  psu== 284                
replace quest_num = 197 if psu == 285 |  psu== 286 |  psu== 287                  
replace quest_num = 198 if psu == 278 |  psu== 279                    
replace quest_num = 199 if psu == 280                      
replace quest_num = 200 if psu == 290                      
replace quest_num = 201 if psu == 276                      
replace quest_num = 202 if psu == 275                      
replace quest_num = 203 if psu == 277                      
replace quest_num = 204 if psu == 271                      
replace quest_num = 205 if psu == 270                      
replace quest_num = 206 if psu == 274                      
replace quest_num = 207 if psu == 272                      
replace quest_num = 208 if psu == 273                      
replace quest_num = 209 if psu == 304                      
replace quest_num = 210 if psu == 305 |  psu== 306                    
replace quest_num = 211 if psu == 303                      
replace quest_num = 212 if psu == 309 |  psu== 312 |  psu== 313 |  psu== 315                
replace quest_num = 213 if psu == 307 |  psu== 308 |  psu== 310 |  psu== 311 |  psu== 314 |  psu== 316            
replace quest_num = 214 if psu == 300                      
replace quest_num = 215 if psu == 297                      
replace quest_num = 216 if psu == 294                      
replace quest_num = 217 if psu == 302                      
replace quest_num = 218 if psu == 299                      
replace quest_num = 219 if psu == 301                      
replace quest_num = 220 if psu == 291                      
replace quest_num = 221 if psu == 292                      
replace quest_num = 222 if psu == 296                      
replace quest_num = 223 if psu == 298                      
replace quest_num = 224 if psu == 293                      
replace quest_num = 225 if psu == 295                      
replace quest_num = 226 if psu == 324                      
replace quest_num = 227 if psu == 323                      
replace quest_num = 228 if psu == 322                      
replace quest_num = 229 if psu == 321                      
replace quest_num = 230 if psu == 320                      
replace quest_num = 231 if psu == 319                      
replace quest_num = 232 if psu == 317                      
replace quest_num = 233 if psu == 318                      
replace quest_num = 234 if psu == 332                      
replace quest_num = 235 if psu == 329 |  psu== 331                    
replace quest_num = 236 if psu == 333 |  psu== 335                    
replace quest_num = 237 if psu == 328 |  psu== 330                    
replace quest_num = 238 if psu == 327 |  psu== 334 |  psu== 326                  
replace quest_num = 239 if psu == 325                      
replace quest_num = 240 if psu == 340                      
replace quest_num = 241 if psu == 342                      
replace quest_num = 242 if psu == 339                      
replace quest_num = 243 if psu == 341                      
replace quest_num = 244 if psu == 344 & hhid<34405                      
replace quest_num = 245 if psu == 344 & hhid>34404                     
replace quest_num = 246 if psu == 348                      
replace quest_num = 247 if psu == 343                      
replace quest_num = 248 if psu == 347 |  psu== 346                    
replace quest_num = 249 if psu == 336                      
replace quest_num = 250 if psu == 337                      
replace quest_num = 251 if psu == 338                      
replace quest_num = 252 if psu == 345                      
replace quest_num = 253 if psu == 350 |  psu== 349 |  psu== 351                  
replace quest_num = 254 if psu == 375                      
replace quest_num = 255 if psu == 371 |  psu== 372 |  psu== 373 |  psu== 374                
replace quest_num = 256 if psu== 380 |  psu== 381 |  psu== 386 |  psu== 398 |  psu== 399 |  psu== 379          
replace quest_num = 257 if psu== 405                
replace quest_num = 258 if psu== 433 |  psu== 434 |  psu== 435 |  psu== 436              
replace quest_num = 259 if psu== 387 |  psu== 407 |  psu== 408 |  psu== 437 |  psu== 409 |  psu== 415 |  psu== 446        
replace quest_num = 260 if psu== 385 |  psu== 397 |  psu== 400 |  psu== 424 |  psu== 425 |  psu== 401 |  psu== 403 |  psu== 404 |  psu== 432 |  psu== 406  
replace quest_num = 261 if  psu== 378 |  psu== 395 |  psu== 382 |  psu== 383 |  psu== 384            
replace quest_num = 262 if   psu== 396 |  psu== 402 |  psu== 426 |  psu== 427 |  psu== 428 |  psu== 429 |  psu== 430 |  psu== 431 |  psu== 438 |  psu== 410 |  psu== 439
replace quest_num = 263 if psu== 420 |  psu== 419 |  psu== 418 |  psu== 392 |  psu== 391 |  psu== 417 |  psu== 377        
replace quest_num = 264 if psu== 444 |  psu== 416 |  psu== 422 |  psu== 421 |  psu== 447 |  psu== 414          
replace quest_num = 265 if psu== 450 |  psu== 412 |  psu== 445 |  psu== 441 |  psu== 440 |  psu== 388 |  psu== 393 |  psu== 442      
replace quest_num = 266 if psu== 411 |  psu== 389 |  psu== 443 |  psu== 423 |  psu== 448 |  psu== 449 |  psu== 413 |  psu== 390      
replace quest_num = 267 if psu == 360                      
replace quest_num = 268 if psu == 354                      
replace quest_num = 269 if psu == 356                      
replace quest_num = 270 if psu == 355                      
replace quest_num = 271 if psu == 359                      
replace quest_num = 272 if psu == 357                      
replace quest_num = 273 if psu == 358                      
replace quest_num = 274 if psu == 362                      
replace quest_num = 275 if psu == 365                      
replace quest_num = 276 if psu == 364                      
replace quest_num = 277 if psu == 366                      
replace quest_num = 278 if psu == 370                      
replace quest_num = 279 if psu == 369                      
replace quest_num = 280 if psu == 368                      
replace quest_num = 281 if psu == 361                      
replace quest_num = 282 if psu == 367                      
replace quest_num = 283 if psu == 363                      
replace quest_num = 284 if psu == 394                      
replace quest_num = 285 if psu == 376                      
replace quest_num = 286 if psu == 193                      
replace quest_num = 287 if psu == 192                      
replace quest_num = 288 if psu == 352                      
replace quest_num = 289 if psu == 353

* we can drop the implicit prices of some items for which we know we do not have prices in the community questionnaire, but we want take into consideration their role
* on the overall budget share, in fact prices for these items should have the same nature of similar ones for which we have price
* information both in the community and household questionnaire. In order to this we recode some of the itc values.

replace psuprice=. if itc==2 | itc==8 | itc==9 | itc==10 | itc==41 | itc==49 | itc==274 | itc==70 | itc==72 | itc==75 | itc==275 | itc==96 | itc==97 | itc==98 | itc==99 /*
*/ | itc==100 | itc==102 | itc==108 | itc==110 | itc==113 | itc==135 | itc==140
replace unit=. if itc==2 | itc==8 | itc==9 | itc==10 | itc==41 | itc==49 | itc==274 | itc==70 | itc==72 | itc==75 | itc==275 | itc==96 | itc==97 | itc==98 | itc==99 /*
*/ | itc==100 | itc==102 | itc==108 | itc==110 | itc==113 | itc==135 | itc==140

* bread and biscuits
recode itc 2=1 8=7 9=7 10=7
* processed veal, frozen chicken, and meat (from checklist)
recode itc 41=40 49=52 274=27
* cheeses, and yogourt
recode itc 70=69 72=69 75=74
* vegetable oil from cheklist
recode itc 275=84
* various fruits
recode itc 96=91 97=91 98=91 99=91 100=91 102=91 108=91 110=91 113=91
* various vegetables
recode itc 135=156 140=156

sort quest_num itc
merge quest_num itc using results\comprices
tab _merge

*** _merge==1

* if _merge==1 items are consumed in a certain psu, but we do not have prices for it in the community questionnaire, we check that we don't leave out any important
* item and that we cannot eventually regroup some items, and then we delete the unusable items.
* In order to do this we use the subgroup variable for an easier identification

* bread
tab itc if _merge==3 & subgroup==1
tab itc if _merge==1 & subgroup==1
drop if _merge==1 & subgroup==1
* cereals
tab itc if _merge==3 & subgroup==2
tab itc if _merge==1 & subgroup==2
drop if _merge==1 & subgroup==2
* meat
tab itc if _merge==3 & subgroup==3
tab itc if _merge==1 & subgroup==3
drop if _merge==1 & subgroup==3
* fish
tab itc if _merge==3 & subgroup==4
tab itc if _merge==1 & subgroup==4
drop if _merge==1 & subgroup==4
* milk
tab itc if _merge==3 & subgroup==5
tab itc if _merge==1 & subgroup==5
drop if _merge==1 & subgroup==5
* oil
tab itc if _merge==3 & subgroup==6
tab itc if _merge==1 & subgroup==6
drop if _merge==1 & subgroup==6
* fruits
tab itc if _merge==3 & subgroup==7
tab itc if _merge==1 & subgroup==7
drop if _merge==1 & subgroup==7
* vegetables
tab itc if _merge==3 & subgroup==8
tab itc if _merge==1 & subgroup==8
drop if _merge==1 & subgroup==8
* conserve
tab itc if _merge==3 & subgroup==9
tab itc if _merge==1 & subgroup==9
drop if _merge==1 & subgroup==9
* sugar
tab itc if _merge==3 & subgroup==10
tab itc if _merge==1 & subgroup==10
drop if _merge==1 & subgroup==10
* spices
tab itc if _merge==3 & subgroup==11
tab itc if _merge==1 & subgroup==11
drop if _merge==1 & subgroup==11
* beverages
tab itc if _merge==3 & subgroup==12
tab itc if _merge==1 & subgroup==12
drop if _merge==1 & subgroup==12
* other
tab itc if _merge==3 & subgroup==13
tab itc if _merge==1 & subgroup==13
drop if _merge==1 & subgroup==13

*** _merge==2 
* these are cases for which we only have information from the community prices, this is because there are no households consuming those items
tab itc if _merge==2
* we can drop these observations
drop if _merge==2

*** _merge==3
* we want to check the amount of not directed prices from the community questionnaire
table _merge, c(n comprice n comprice1)
* about 10% of prices are indirectly estimated
drop _merge

gen psuprice1=psuprice
egen mpsuprice=median(psuprice), by(psu itc)
replace psuprice1=mpsuprice if psuprice1==.
tab itc if psuprice1==. 
egen mpsuprice1=median(psuprice), by(district urbrur itc)
replace psuprice1=mpsuprice1 if psuprice1==.
tab itc if psuprice1==. 
egen mpsuprice2=median(psuprice), by(prefect urbrur itc)
replace psuprice1=mpsuprice2 if psuprice1==.
tab itc if psuprice1==. 
egen mpsuprice3=median(psuprice), by(stratum urbrur itc)
replace psuprice1=mpsuprice3 if psuprice1==.
tab itc if psuprice1==. 
egen munit=median(unit), by(itc)
replace unit=munit if unit==.
tab itc if unit==.
collapse (sum) exp (mean) psu-psuprice psuprice1 unit comprice comprice1, by(hhid itc)
sort hhid
save results\prices1, replace


