********************************************
****                                    ****
****             Daily index            ****
****                                    ****
********************************************

clear
set mem 40m

* From the daily index we exclude items reported in the check list
* 1) check that the date of interview is the first day of the daily notebook
* 2) calculate daily index from day 1 to 14

use results\food, clear
drop if type==0
gen date1=month*100+day
save temp, replace
gen one=1
gen sum=sum(one)
collapse (max) sum, by(hhid)
gen sum1=sum[_n-1]
replace sum1=0 in 1
sort hhid
save temp1, replace
use temp, clear
sort hhid
merge hhid using temp1
tab _merge
drop _merge

sort hhid date itc type
gen one=1
gen sum2=sum(one)
gen first=sum2-sum1
count if first==1
gen test=date1-date if first==1
sum test, det
* there are some discrepancies

drop date1-sum2
save temp, replace
gen one=1
gen sum=sum(one)
collapse (max) sum, by(hhid date)
gen sum1=sum[_n-1]
replace sum1=0 in 1
sort hhid date
save temp1, replace
use temp, clear
sort hhid date
merge hhid date using temp1
tab _merge
drop _merge
sort hhid date itc type
gen one=1
gen sum2=sum(one)
gen newday=sum2-sum1

drop sum-sum2
gen date11=date if first==1
egen firstdate=max(date11), by(hhid)
drop date11

gen fmonth=int(firstdate/100)
gen fday=firstdate-fmonth*100
gen nmonth=int(date/100)
gen nday=date-nmonth*100
gen year=2002
gen fdate=mdy(fmonth, fday, year) if newday==1
gen ndate=mdy(nmonth, nday, year) if newday==1
gen days=ndate-fdate
replace days=days+1
egen daynumber=max(days), by(hhid date)
save temp, replace

use temp
drop daynumber
gen daynumber=1
collapse (mean) daynumber, by(hhid)
sort hhid
save temp1, replace
local i = 2
while `i' <= 14 {
use temp1, clear
drop daynumber
gen daynumber=`i'
sort hhid daynumber
save temp`i', replace
local i = `i' + 1
}

local i = 2
while `i' <= 14 {
use temp1, clear
sort hhid daynumber
merge hhid daynumber using temp`i'
drop _merge
save temp1, replace
local i = `i' + 1
}

use temp, clear
gen one=1
collapse (sum) ntrans=one, by(hhid daynumber)
sort hhid daynumber
save temp2, replace

use temp1, clear
sort hhid daynumber
merge hhid daynumber using temp2
tab _merge
replace ntrans=0 if _merge==1
drop _merge
sort hhid
merge hhid using results\base
tab _merge
drop _merge
save temp2, replace

* we want to add also household size
use results\hhroster, clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
save temp3, replace
use temp2, clear
sort hhid
merge hhid using temp3
tab _merge
drop _merge
egen avtrans=mean(ntrans), by(hhid)
gen index=100*ntrans/avtrans

* we can always produce these estimates for different areas, but for now we distinguish between urban and rural
table daynumber urbrur [aw=weight], c(m index) col

collapse (mean) avtrans hhsize urbrur weight, by(hhid)
table urbrur [aw=weight], c(m avtrans m hhsize) row

!del temp*.dta


