*** This file computes food expenditure using the daily notebook, and makes some general testing

clear
set mem 40m

* Food expenses

use data\bnonpurchased_cl.dta, clear
sum
gen date=mab_q08m*100+mab_q08d
rename mab_q03 code
keep mab_q01-date
gen type=2
sort hhid date code type
save temp, replace

use data\bfoodeaten_cl.dta, clear
sum
gen date=mac_q08m*100+mac_q08d
rename mac_q03 code
keep mac_q01-date
gen type=3
sort hhid date code type
save temp1, replace

*** include check list (there are two items, which actually represent a group of items, for these the unit values would be unappropriate, so we need to distinguish them)
use data\bchecklist_cl, clear
des
keep if mad_q07!=. & mad_q07!=0
rename mad_q0a code1
encode code1, gen(itc)
recode itc 5=998 8=999
* this is meat
label def itc 998 "99998", add
* this is vegetable oil
label def itc 999 "99999", add
lab val itc itc
decode itc, gen(code)
keep psu hhid code mad_q04-mad_q07
gen type=0
sort hhid code type
save temp2, replace

use data\bookdaily_cl.dta, clear
gen date=maa_q08m*100+maa_q08d
rename maa_q03 code
keep maa_q01-date
gen type=1
sort hhid date code type
merge hhid date code type using temp
tab _merge
drop _merge
sort hhid date code type
merge hhid date code type using temp1
tab _merge
drop _merge
sort hhid code type
merge hhid code type using temp2
tab _merge
drop _merge
drop psu
sort hhid
merge hhid using results\base
tab _merge
drop _merge
label def type 0 "check"
label def type 1 "purchased", add
label def type 2 "non purchased", add
label def type 3 "eaten outside", add
label val type type
sort hhid date code type
encode code, gen(itc)

* generate unit values by code and unit of measurement
gen unit=maa_q05
replace unit=mab_q05 if unit==.
replace unit=mad_q06 if unit==.
drop maa_q05 mab_q05 mad_q06
lab val unit MAA_Q05

gen value=maa_q06
replace value=mab_q06 if value==.
replace value=mac_q04 if value==.
replace value=mad_q07 if value==.
drop maa_q06 mab_q06 mac_q04 mad_q07
gen quant=maa_q04
replace quant=mab_q04 if quant==. & mab_q01!=.
replace quant=1 if mac_q01!=. & quant==.
replace quant=mad_q05 if quant==.
replace unit=3 if mac_q01!=.
drop maa_q01 maa_q04 mab_q01 mab_q04 mac_q01 mad_q05

count if unit==.
egen umode=mode(unit), max by(hhid itc)
list itc umode if unit==.
recode unit .=3
drop umode

count if quant==0 & value==.
count if quant!=. & value==.
list itc unit quant value if quant!=. & value==.
count if quant==. & value!=.
list itc unit quant value if quant==. & value!=.

sum value quant, d
list itc unit quant value if value==999999
recode value 999999=.
list itc unit quant value if quant>9999 & quant!=.
replace quant=. if quant>9999 & quant!=.

*** some corrections on the period of consumption after checking the questionnaire
replace maa_q07=1 if hhid==35203 & itc==69 & value==900 & type==1
replace maa_q07=2 if hhid==701 & itc==27 & value==4000 & type==1
replace maa_q07=3 if hhid==19008 & itc==176 & value==1200 & type==1
replace maa_q07=4 if hhid==35402 & itc==148 & value==1000 & type==1
replace maa_q07=2 if hhid==42901 & itc==69 & value==900 & type==1
replace maa_q07=2 if hhid==33606 & itc==27 & value==5500 & type==1
replace maa_q07=2 if hhid==33608 & itc==27 & value==4000 & type==1
replace maa_q07=2 if hhid==33709 & itc==176 & value==1200 & type==1
replace maa_q07=2 if hhid==34702 & itc==34 & value==5500 & type==1
replace maa_q07=2 if hhid==34702 & itc==156 & value==500 & type==1
replace maa_q07=2 if hhid==34703 & itc==27 & value==4200 & type==1
replace maa_q07=2 if hhid==34703 & itc==69 & value==900 & type==1
replace maa_q07=2 if hhid==34709 & itc==27 & value==3000 & type==1
replace maa_q07=2 if hhid==42408 & itc==76 & value==600 & type==1
replace maa_q07=2 if hhid==19706 & itc==85 & value==400 & type==1
replace maa_q07=2 if hhid==37004 & itc==217 & value==500 & type==1
replace maa_q07=2 if hhid==38205 & itc==27 & value==2600 & type==1
replace maa_q07=2 if hhid==38205 & itc==85 & value==500 & type==1
replace maa_q07=2 if hhid==43404 & itc==27 & value==3250 & type==1
replace maa_q07=3 if hhid==33608 & itc==27 & value==5500 & type==1
replace maa_q07=3 if hhid==42901 & itc==85 & value==2500 & type==1
replace maa_q07=5 if hhid==42901 & itc==176 & value==2500 & type==1
replace maa_q07=5 if hhid==42408 & itc==176 & value==2400 & type==1
replace maa_q07=2 if hhid==3507 & value==5500 & itc==34
replace maa_q07=4 if hhid==4808 & value==9900 & itc==13
replace maa_q07=2 if hhid==7108 & value==6000 & itc==27
replace maa_q07=2 if hhid==8003 & value==5500 & itc==27
replace maa_q07=4 if hhid==8903 & value==10800 & itc==15
replace maa_q07=4 if hhid==15804 & value==18000 & itc==27
replace maa_q07=4 if hhid==16504 & value==10800 & itc==13
replace maa_q07=3 if hhid==21005 & value==6500 & itc==34
replace maa_q07=2 if hhid==24907 & value==6500 & itc==27
replace maa_q07=2 if hhid==25406 & value==5200 & itc==34
replace maa_q07=2 if hhid==25908 & value==6500 & itc==34
replace maa_q07=2 if hhid==26808 & value==6000 & itc==34
replace maa_q07=2 if hhid==27006 & value==6500 & itc==27
replace maa_q07=2 if hhid==27006 & value==7000 & itc==34
replace maa_q07=2 if hhid==27106 & value==5500 & itc==27
replace maa_q07=2 if hhid==32001 & value==6000 & itc==34
replace maa_q07=2 if hhid==32302 & value==6000 & itc==34
replace maa_q07=2 if hhid==32308 & value==6000 & itc==34
replace maa_q07=2 if hhid==32908 & value==6500 & itc==27
replace maa_q07=2 if hhid==33506 & value==6000 & itc==27
replace maa_q07=5 if hhid==33609 & value==40000 & itc==69
replace maa_q07=2 if hhid==34609 & value==7000 & itc==27
replace maa_q07=2 if hhid==34702 & value==5500 & itc==34
replace maa_q07=5 if hhid==35607 & value==6000 & itc==34
replace maa_q07=2 if hhid==38201 & value==6000 & itc==27
replace maa_q07=2 if hhid==38307 & value==6500 & itc==27
*** some corrections on the value after checking the questionnaire
replace value=390 if hhid==32908 & itc==15 & value==3900
replace value=220 if hhid==37004 & itc==13 & value==2200
replace value=680 if value==6803
recode value 7000=700 9000=900 if hhid==10405 & itc==273
recode value 2700=1700 if hhid==41303 & itc==273
replace value=600 if hhid==10406 & value==6000 & itc==12
replace value=1200 if hhid==10406 & value==12000 & itc==15
replace value=1700 if hhid==10406 & value==17000 & itc==15
replace value=1650 if hhid==10702 & value==16500 & itc==27
replace value=1650 if hhid==11103 & value==16500 & itc==27
replace value=510 if hhid==12507 & value==5100 & itc==84
replace value=1700 if hhid==16905 & value==17000 & itc==13
replace value=1950 if hhid==23306 & value==19500 & itc==28
replace value=150 if hhid==26905 & value==15150 & itc==69
replace value=2500 if hhid==32008 & value==25000 & itc==13
replace value=550 if hhid==39808 & value==5500 & itc==49
replace value=800 if hhid==43309 & value==8000 & itc==85
replace value=650 if hhid==44605 & value==6500 & itc==27

gen uvalue=value/quant
egen euvalue1=median(uvalue), by(code unit psu)
egen euvalue2=median(uvalue), by(code unit district)
egen euvalue3=median(uvalue), by(code unit stratum)

* see whether we have any value to impute
count if quant==0 & value==.
count if quant!=. & value==.
replace value=quant*euvalue1 if quant!=. & value==.
replace value=quant*euvalue2 if quant!=. & value==.
replace value=quant*euvalue3 if quant!=. & value==.

count if quant==. & value!=.
replace quant=value/euvalue1 if quant==. & value!=.
replace quant=value/euvalue2 if quant==. & value!=.
replace quant=value/euvalue3 if quant==. & value!=.

count if quant==0 & value==0
count if quant==0 & value!=0
replace quant=value/euvalue1 if quant==0 & value!=0
replace quant=value/euvalue2 if quant==. & value!=.

count if quant!=0 & value==0

* we now replace the unit value for the cases in which it was missing
replace uvalue=value/quant if uvalue==.

*** through question a7 we can identify bulk expenses, and consequently adjust value of expenditure for the period of 14 days
*** this needs to be discussed!!!

* first of all we check that there exist a positive relationship between period of consumption and value of expenditure
*table itc maa_q07, c(m value med value)
* another way to check the same thing is with a regression
*local i = 20
*while `i' <= 240 {
*local prev=`i'-20
*gen newc`i'=itc if itc>`prev' & itc<=`i' & maa_q07!=.
*xi: reg value maa_q07 i.newc`i'
*drop _Inew* newc*
*local i = `i' + 20
*}
* the coefficient of the period is always positive and significant

gen foodexp=value
replace foodexp=value/2 if maa_q07==2
replace foodexp=value/4 if maa_q07==3
replace foodexp=value/6 if maa_q07==4
replace foodexp=value/24 if maa_q07==5
replace foodexp=value/2 if mad_q04==2
replace foodexp=value/4 if mad_q04==3
replace foodexp=value/6 if mad_q04==4
replace foodexp=value/24 if mad_q04==5
gen quant1=quant
replace quant1=quant/2 if maa_q07==2
replace quant1=quant/4 if maa_q07==3
replace quant1=quant/6 if maa_q07==4
replace quant1=quant/24 if maa_q07==5
replace quant1=quant/2 if mad_q04==2
replace quant1=quant/4 if mad_q04==3
replace quant1=quant/6 if mad_q04==4
replace quant1=quant/24 if mad_q04==5

* add main subgroup of food items
save temp, replace
use results\subgroup, clear
sort itc
save temp1, replace
use temp, clear
sort itc
merge itc using temp1
tab _merge
drop _merge
* two items from the cheklist can only be included in the sub-aggregate (vegetable oil and meat)
replace subgroup=3 if itc==274
replace subgroup=6 if itc==275
replace subgroup=13 if type==3 & subgroup==.
count if subgroup==.
recode subgroup .=15
* there is one problem with the code of one item that is recorded in two different subgroups
recode subgroup 15=13 if itc==245 & hhid==33104 & type==1
tab subgroup
* we readjust the values of subgroups
recode subgroup 15=16 13=14
recode subgroup 16=13
tab subgroup
label def subgroup 1 "bread"
label def subgroup 2 "cereals", add
label def subgroup 3 "meat", add
label def subgroup 4 "fish", add
label def subgroup 5 "milk", add
label def subgroup 6 "oil", add
label def subgroup 7 "fruits", add
label def subgroup 8 "veget", add
label def subgroup 9 "conserved", add
label def subgroup 10 "sugar", add
label def subgroup 11 "spices", add
label def subgroup 12 "beverages", add
label def subgroup 13 "other", add
label def subgroup 14 "food out", add
label val subgroup subgroup
compress
save results\food, replace

clear
set mem 30m

*** Now we want to check and correct eventual outliers

* the strategy adopted is the following:
* 1. Compute food shares of several subgroups for each household, and check those households where the food share is above a certain limit
* (the mean value + 2 times the standard error) 
* 2. Households are checked and we register anomalies if the per capita expenditure for a certain item exceeds 10 times the median value
* 3. Anomalies above mentioned are checked at the transaction level to see whether unit values are strange and in those cases values are corrected multipling
* quantity by unit value
* 4. The process is repeated a number of times


* 1. Compute food consumption by main sub-groups and compute food shares

use results\food, clear
collapse (mean) urbrur-weight (sum) foodexp, by(hhid subgroup)
local i = 1
while `i' <= 14 {
gen group`i'=foodexp if subgroup==`i'
local i = `i' + 1
}
collapse (sum) group1-group14, by(hhid)
for var group1-group14: recode X 0=.
egen food=rsum(group1-group14)

local i = 1
while `i' <= 14 {
gen grsh`i'=group`i'/food
local i = `i' + 1
}

* Just to check
egen tot=rsum(grsh1-grsh14)
sum tot
drop tot
sort hhid
save temp, replace

* 2. Compute expenses by household and items and add hhsize to the file

use results\hhroster, clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save temp0, replace
use results\food, clear
* check for eventual miscoding of items across subgroups
collapse (mean) subgroup (max) subgrmax=subgroup (min) subgrmin=subgroup (sum) itcexp=foodexp, by(hhid itc)
count if subgrmax!=subgrmin
* ok
drop subgrmax subgrmin
tab subgroup
sort hhid
merge hhid using temp0
tab _merge
drop _merge
gen itcexpc=itcexp/hhsize
egen meditc=median(itcexpc), by(itc)
save temp0, replace

* 2. Identify households for which food share is abnormal

* we exclude these tests for food eaten outside home (subgroup==14)

local i = 1
while `i' <= 13 {
use temp, clear
egen mgrsh`i'=mean(grsh`i')
egen sdgrsh`i'=sd(grsh`i')
gen test=1 if grsh`i'>(mgrsh`i'+2*sdgrsh`i') & grsh`i'!=.
keep if test==1
keep hhid food test grsh`i'
sort hhid
save temp`i', replace
use temp0, clear
keep if subgroup==`i'
sort hhid
merge hhid using temp`i'
tab _merge
keep if _merge==3
drop _merge
gen test1=(itcexp/hhsize)/meditc
keep if test1>5
sort hhid itc
save temp`i', replace
use results\food, clear
keep if subgroup==`i'
sort hhid itc
merge hhid itc using temp`i'
tab _merge
gen share=foodexp/itcexp
egen max=max(share), by(hhid itc)
gen share1=itcexp/food
egen max1=max(share1), by(hhid)
gen test2=uvalue/euvalue1 if _merge==3
gen test3=uvalue/euvalue3

* possible mistakes in the unit value
count if max==share & max1==share1 & test2>=5 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if max==share & max1==share1 & test2>=5 & _merge==3 

replace value=quant*euvalue1 if max==share & max1==share1 & test2>=5 & _merge==3
gen correct=1 if max==share & max1==share1 & test2>=5 & _merge==3

count if max==share & max1==share1 & test3>=5 & _merge==3 & correct!=1
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 euvalue3 if max==share & max1==share1 & test3>=5 & correct!=1 & _merge==3 

replace value=quant*euvalue3 if max==share & max1==share1 & test3>=5 & _merge==3 & correct!=1
replace correct=1 if max==share & max1==share1 & test3>=5 & _merge==3

* possible mistakes in values and quantities: there are more than two transactions of the same item and one of them singles out as very expensive
gen one=1
egen number=sum(one), by(hhid itc)
egen medval=median(value), by(hhid itc)
count if number>2 & value>5*medval & max==share & max1==share1 & (maa_q07==0 | maa_q07==.) & correct!=1 & _merge==3
capture gen test4=1 if number>2 & value>5*medval & max==share & max1==share1 & (maa_q07==0 | maa_q07==.) & correct!=1 & _merge==3

list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if test4==1

replace value=medval if test4==1
replace quant=value/euvalue1 if test4==1
replace correct=1 if test4==1

* possible mistakes in the period of expenditure

* we do have only one transaction and its value is abnormally high
count if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3

list hhid maa_q07 mad_q04 type itc unit quant value test1 uvalue euvalue1  if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3

replace value=meditc*hhsize if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3
replace quant=value/euvalue1 if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3
replace correct=1 if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & _merge==3

* there are more than two purchases that should be consumed in the period of 15 days or more
count if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if number>=2 & maa_q07!=0 & maa_q07!=. & correct!=1 & _merge==3

capture egen maxexp=max(foodexp) if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3, by(hhid itc)
count if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
list hhid maa_q07 type itc unit quant value test1 if maxexp==foodexp & test1>=10 & correct!=1 & _merge==3
replace value=0 if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
replace quant=0 if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
replace correct=1 if maxexp==foodexp & test1>=10 & _merge==3

* There are very high values for periods of consumption within two weeks, we presume that the period of consumption is longer

count if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3

list hhid maa_q07 mad_q04 type itc unit quant value test1 uvalue euvalue1  if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3

replace value=(meditc*hhsize)/number if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3
replace quant=value/euvalue1 if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3
replace correct=1 if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & _merge==3

list test1 test2 grsh`i' if correct==1 
tab test1 if test1>=10 & _merge==3
tab grsh`i' if  _merge==3

* recreate foodexp and quant1 to incorporate corrections
replace foodexp=value
replace foodexp=value/2 if maa_q07==2
replace foodexp=value/4 if maa_q07==3
replace foodexp=value/6 if maa_q07==4
replace foodexp=value/24 if maa_q07==5
replace foodexp=value/2 if mad_q04==2
replace foodexp=value/4 if mad_q04==3
replace foodexp=value/6 if mad_q04==4
replace foodexp=value/24 if mad_q04==5
replace quant1=quant
replace quant1=quant/2 if maa_q07==2
replace quant1=quant/4 if maa_q07==3
replace quant1=quant/6 if maa_q07==4
replace quant1=quant/24 if maa_q07==5
replace quant1=quant/2 if mad_q04==2
replace quant1=quant/4 if mad_q04==3
replace quant1=quant/6 if mad_q04==4
replace quant1=quant/24 if mad_q04==5

drop itcexp itcexpc-test3 one-maxexp
sort hhid itc
save group`i', replace
local i = `i' + 1
}

* subgroup 14 (food eaten outside) needs to be cleaned in a different manner

use temp, clear
keep if group14!=.
keep hhid food grsh14
sort hhid
save temp14, replace
use temp0, clear
keep if subgroup==14
sort hhid
merge hhid using temp14
tab _merge
keep if _merge==3
drop _merge
gen test1=(itcexp/hhsize)/meditc
sort hhid itc
save temp14, replace
use results\food, clear
keep if subgroup==14
sort hhid itc
merge hhid itc using temp14
tab _merge
drop _merge
gen share=foodexp/itcexp
egen max=max(share), by(hhid itc)
gen share1=itcexp/food
egen max1=max(share1), by(hhid)

* In this type of expenditure we do not have unit values, but we can check if values are abnormal and expenditure share is particularly high

* possible mistakes in values, there are more than two transactions of the same item and one of them singles out as very expensive
gen one=1
egen number=sum(one), by(hhid itc)
egen medval=median(value), by(hhid itc)
count if number>2 & value>10*medval
gen test4=1 if number>2 & value>10*medval
list hhid itc number value medval test1 grsh14 share max share1 max1 if test4==1
gen correct=1 if test4==1
replace value=value/10 if test4==1

* extremely high values
count if test1>=10 & share==max & correct!=1 & number<=2 & share1==max1
list hhid itc number value medval meditc test1 grsh14 share1 if test1>=10 & share==max & correct!=1 & number<=2 & share1==max1
replace value=value/10 if test1>=10 & share==max & correct!=1 & share1==max1
replace correct=1 if test1>=10 & share==max & correct!=1 & share1==max1

count if value>1000

* there are still some very high values for food eaten outside, it seems that some of these are exceptional events, so that we can correct soem of these
* high expenses when they happen only once in the period of the diary, and we substitute them with the median value

tab itc if value>1000, nol
recode itc 270=273
gen one1=1 if value>2000
egen number1=sum(one1), by(hhid)
tab number1
gen obs=1
egen sum=sum(obs), by(urbrur itc)
tab sum if one1==1 & number1==1
egen med=median(value), by(urbrur itc)
list value med if one1==1 & number1==1
replace value=med if one1==1 & number1==1
replace correct=1 if one1==1 & number1==1

* recreate foodexp to incorporate corrections
replace foodexp=value

drop itcexp itcexpc-test4 one1-med
sort hhid itc
save group14, replace

local i = 2
while `i' <= 14 {
use group1, clear
sort hhid itc
merge hhid itc using group`i'
tab _merge
drop _merge
sort hhid itc
save group1, replace
local i = `i' + 1
}

collapse (sum) correct, by(hhid)
sort hhid
save correct, replace

use group1, clear
drop if value==0
drop code uvalue-euvalue3 hhsize correct
gen uvalue=value/quant
egen euvalue1=median(uvalue), by(itc unit psu)
egen euvalue2=median(uvalue), by(itc unit district)
egen euvalue3=median(uvalue), by(itc unit stratum)
sort hhid itc
save results\food, replace

!del group*.dta
!del temp*.dta

***********************************************************************************
******                                                                       ******
******         Now we repeat once more the same cleaning process             ******
******                                                                       ******
***********************************************************************************

* 1. Compute food consumption by main sub-groups and compute food shares

use results\food, clear
collapse (mean) urbrur-weight (sum) foodexp, by(hhid subgroup)
local i = 1
while `i' <= 14 {
gen group`i'=foodexp if subgroup==`i'
local i = `i' + 1
}
collapse (sum) group1-group14, by(hhid)
for var group1-group14: recode X 0=.
egen food=rsum(group1-group14)

local i = 1
while `i' <= 14 {
gen grsh`i'=group`i'/food
local i = `i' + 1
}

sort hhid
save temp, replace

* 2. Compute expenses by household and items and add hhsize to the file

use results\hhroster, clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save temp0, replace
use results\food, clear
collapse (mean) subgroup (sum) itcexp=foodexp, by(hhid itc)
sort hhid
merge hhid using temp0
tab _merge
drop _merge
gen itcexpc=itcexp/hhsize
egen meditc=median(itcexpc), by(itc)
save temp0, replace

* 2. Identify households for which food share is abnormal

* we exclude these tests for food eaten outside home (subgroup==14)

local i = 1
while `i' <= 13 {
use temp, clear
egen mgrsh`i'=mean(grsh`i')
egen sdgrsh`i'=sd(grsh`i')
gen test=1 if grsh`i'>(mgrsh`i'+2*sdgrsh`i') & grsh`i'!=.
keep if test==1
keep hhid food test grsh`i'
sort hhid
save temp`i', replace
use temp0, clear
keep if subgroup==`i'
sort hhid
merge hhid using temp`i'
tab _merge
keep if _merge==3
drop _merge
gen test1=(itcexp/hhsize)/meditc
keep if test1>5
sort hhid itc
save temp`i', replace
use results\food, clear
keep if subgroup==`i'
sort hhid itc
merge hhid itc using temp`i'
tab _merge
gen share=foodexp/itcexp
egen max=max(share), by(hhid itc)
gen share1=itcexp/food
egen max1=max(share1), by(hhid)
gen test2=uvalue/euvalue1 if _merge==3
gen test3=uvalue/euvalue3

* possible mistakes in the unit value
count if max==share & max1==share1 & test2>=5 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if max==share & max1==share1 & test2>=5 & _merge==3 

replace value=quant*euvalue1 if max==share & max1==share1 & test2>=5 & _merge==3
gen correct=1 if max==share & max1==share1 & test2>=5 & _merge==3

count if max==share & max1==share1 & test3>=5 & _merge==3 & correct!=1
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 euvalue3 if max==share & max1==share1 & test3>=5 & correct!=1 & _merge==3 

replace value=quant*euvalue3 if max==share & max1==share1 & test3>=5 & _merge==3 & correct!=1
replace correct=1 if max==share & max1==share1 & test3>=5 & _merge==3

* possible mistakes in values and quantities: there are more than two transactions of the same item and one of them singles out as very expensive
gen one=1
egen number=sum(one), by(hhid itc)
egen medval=median(value), by(hhid itc)
count if number>2 & value>5*medval & max==share & max1==share1 & (maa_q07==0 | maa_q07==.) & correct!=1 & _merge==3
capture gen test4=1 if number>2 & value>5*medval & max==share & max1==share1 & (maa_q07==0 | maa_q07==.) & correct!=1 & _merge==3

list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if test4==1

replace value=medval if test4==1
replace quant=value/euvalue1 if test4==1
replace correct=1 if test4==1

* possible mistakes in the period of expenditure

* we do have only one transaction and its value is abnormally high
count if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3

list hhid maa_q07 mad_q04 type itc unit quant value test1 uvalue euvalue1  if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3

replace value=meditc*hhsize if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3
replace quant=value/euvalue1 if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & correct!=1 & _merge==3
replace correct=1 if number==1 & (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & max==share & max1==share1 & _merge==3

* there are more than two purchases that should be consumed in the period of 15 days or more
count if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3
list hhid maa_q07 type itc unit quant value test1 uvalue euvalue1 if number>=2 & maa_q07!=0 & maa_q07!=. & correct!=1 & _merge==3

capture egen maxexp=max(foodexp) if number>=2 & maa_q07!=0 & maa_q07!=. & max==share & max1==share1 & correct!=1 & _merge==3, by(hhid itc)
count if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
list hhid maa_q07 type itc unit quant value test1 if maxexp==foodexp & test1>=10 & correct!=1 & _merge==3
replace value=0 if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
replace quant=0 if maxexp==foodexp & test1>=10 & _merge==3 & correct!=1
replace correct=1 if maxexp==foodexp & test1>=10 & _merge==3

* There are very high values for periods of consumption within two weeks, we presume that the period of consumption is longer

count if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3

list hhid maa_q07 mad_q04 type itc unit quant value test1 uvalue euvalue1  if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3

replace value=(meditc*hhsize)/number if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3
replace quant=value/euvalue1 if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & correct!=1 & _merge==3
replace correct=1 if (((maa_q07==. | maa_q07==0 | maa_q07==1) & type==1) | type==2 | (type==0 & (mad_q04==1 | mad_q04==0 | mad_q04==.))) & test1>=10 & max==share & max1==share1 & _merge==3

list test1 test2 grsh`i' if correct==1 
tab test1 if test1>=10 & _merge==3
tab grsh`i' if  _merge==3

* recreate foodexp and quant1 to incorporate corrections
replace foodexp=value
replace foodexp=value/2 if maa_q07==2
replace foodexp=value/4 if maa_q07==3
replace foodexp=value/6 if maa_q07==4
replace foodexp=value/24 if maa_q07==5
replace foodexp=value/2 if mad_q04==2
replace foodexp=value/4 if mad_q04==3
replace foodexp=value/6 if mad_q04==4
replace foodexp=value/24 if mad_q04==5
replace quant1=quant
replace quant1=quant/2 if maa_q07==2
replace quant1=quant/4 if maa_q07==3
replace quant1=quant/6 if maa_q07==4
replace quant1=quant/24 if maa_q07==5
replace quant1=quant/2 if mad_q04==2
replace quant1=quant/4 if mad_q04==3
replace quant1=quant/6 if mad_q04==4
replace quant1=quant/24 if mad_q04==5

drop itcexp itcexpc-test3 one-maxexp
sort hhid itc
save group`i', replace
local i = `i' + 1
}

* subgroup 14 (food eaten outside) does not need corrections

use results\food, clear
keep if subgroup==14
sort hhid itc
save group14, replace

local i = 2
while `i' <= 14 {
use group1, clear
sort hhid itc
merge hhid itc using group`i'
tab _merge
drop _merge
sort hhid itc
save group1, replace
local i = `i' + 1
}

collapse (sum) correct1=correct, by(hhid)
sort hhid
merge hhid using correct
tab _merge
drop _merge
egen numcorr=rsum(correct correct1)
tab numcorr
egen totcor=sum(numcorr)
sum totcor

*** 738 corrections

use group1, clear
drop if value==0
drop uvalue-euvalue3 hhsize correct
gen uvalue=value/quant
egen euvalue1=median(uvalue), by(itc unit psu)
sort hhid itc
save results\food, replace

!del group*.dta
!del temp*.dta
!del correct.dta



