
***** we still check for very high values

use results\hhroster, clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save temp0, replace
use results\food, clear
sort hhid
merge hhid using temp0
tab _merge
drop _merge
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize
list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>3000 & type==2 & foodexp!=.

* these transactions are more likely to be monthly consumption
gen foodexp1=60 if foodexp==60 & hhid==36105 & type==2 & itc==78
replace foodexp1=foodexp/12 if itc==176 & type==2 & foodexp>3000
replace foodexp1=foodexp1/2 if type==2 & foodexp>3000 & hhid!=2702 & hhid!=34702 & hhid!=34709
replace foodexp1=foodexp/4 if type==2 & foodexp>3000 & (hhid==2702 | hhid==34702 | hhid==34709)

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>2000 &  foodexp<=3000 & type==2 & foodexp!=.

replace foodexp1=foodexp/12 if itc==176 & type==2 & foodexp>2000 & foodexp<=3000
replace foodexp1=foodexp/3 if itc==13 & type==2 & foodexp>2000 & foodexp<=3000
replace foodexp1=foodexp/2 if itc==85 & type==2 & foodexp>2000 & foodexp<=3000
replace foodexp1=foodexp/12 if itc==143 & type==2 & foodexp>2000 & foodexp<=3000

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>2000 &  foodexp<=3000 & type==2 & foodexp!=. & share>0.2

replace foodexp1=foodexp/2 if type==2 & share>0.2 & foodexp>2000 & foodexp<=3000

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & share>0.2

replace foodexp1=foodexp/12 if type==2 & share>0.2 & foodexp>1000 & foodexp<=2000 & (itc==148 | itc==176)
replace foodexp1=foodexp/2 if type==2 & share>0.2 & foodexp>1000 & foodexp<=2000

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & share>0.1

replace foodexp1=foodexp/2 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc==13

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & share>0.1 & itc!=27 & itc!=34

replace foodexp1=foodexp/2 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc==85
replace foodexp1=foodexp/6 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & (itc==143 | itc==148 | itc==176)

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & share>0.1 & itc!=27 & itc!=34

replace foodexp1=quant1*euvalue1 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & ((unit==1 & itc==76) | itc==2)
replace foodexp1=foodexp/10 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc==78
replace foodexp1=foodexp/2 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc==69
replace foodexp1=foodexp/10 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc==72

drop share totfood quantpc
egen totfood=sum(foodexp), by(hhid)
gen share=foodexp/totfood
gen quantpc=quant/hhsize

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & share>0.1 & itc!=27 & itc!=34

replace foodexp1=foodexp/2 if type==2 & share>0.1 & foodexp>1000 & foodexp<=2000 & itc!=27 & itc!=34

list hhid day urbrur itc foodexp share unit quant quantpc uvalue euvalue1 hhsize if foodexp>1000 &  foodexp<=2000 & type==2 & foodexp!=. & itc!=27 & itc!=34

replace foodexp1=foodexp/2 if type==2 & foodexp>1000 & foodexp<=2000 & itc!=27 & itc!=34

count if foodexp1!=.
gen correct=1 if foodexp1!=.

egen umode=mode(unit), by(itc)
egen medpric=median(uvalue) if unit==umode, by(itc)
egen medprice=mean(medpric), by(itc)

replace quant1=foodexp1/medprice if foodexp1!=.
replace foodexp1=foodexp if foodexp1==.
sum foodexp foodexp1, det
drop hhsize totfood-quantpc umode-medprice
save results\food1, replace


* We calculate an approximate value of calories per adult equivalent in each household

clear
set mem 40m

use results\hhroster, clear
count if m1_q05y==.
tab m1_q05y
rename m1_q05y age
gen child5=1 if age<=5
gen child6_15=1 if age>=6 & age<=15
gen adult=1 if age>=16 & age<=59
gen elder=1 if age>=60
gen hhsize=1
collapse (sum) hhsize child5 child6_15 adult elder, by(hhid)
* equivalence scale
replace child5=0.5*child5
replace child5=0.8*child6_15
replace elder=0.8*elder
egen ehhsize=rsum(child5 child6_15 adult elder)
keep hhid hhsize ehhsize
sort hhid
save temp0, replace
use results\food1, clear
sort hhid
merge hhid using temp0
tab _merge
drop _merge
drop if value==. & quant==.

* most frequent unit
egen umode=mode(unit), by(itc)

egen medpric=median(uvalue) if unit==umode, by(itc)
egen medprice=mean(medpric), by(itc)
drop medpric
sort hhid itc
save temp, replace

use temp, clear
collapse (sum) foodexp (mean) medprice urbrur umode hhsize ehhsize weight, by(hhid itc)
gen pweight=weight*hhsize

gen quantpc=(foodexp/medprice)/ehhsize

* calculate calories
sort itc
merge itc using results\calories
tab _merge
egen totfood=sum(foodexp), by(hhid)
egen valcal=sum(foodexp) if _merge==3 & quantpc!=., by(hhid)
keep if _merge==3 & quantpc!=.
gen test=totfood/valcal
sum test
gen calunit=calories/100 if umode==1
replace calunit=calories*10 if umode==2 | umode==4
replace calunit=calories if umode==3
gen calitc=quantpc*calunit
egen calpc=sum(calitc), by(hhid)
replace calpc=calpc*test

collapse (mean) calpc urbrur totfood hhsize ehhsize pweight, by(hhid)

replace calpc=calpc/14
label var calpc "calories per adult equivalent per day"
sum calpc [aw=pweight], det

table urbrur [aw=pweight], c(m calpc med calpc)

keep hhid calpc
sort hhid
save temp1, replace

* we use this file to see in which households there might be strange values

use temp, clear
collapse (sum) foodexp (mean) medprice urbrur umode hhsize ehhsize weight subgroup, by(hhid itc)
gen pweight=weight*hhsize
gen quantpc=(foodexp/medprice)/hhsize
egen medquantpc=median(quantpc), by(urbrur itc)
gen test=quantpc/medquantpc
sort hhid
merge hhid using temp1
tab _merge
drop _merge
keep if test>5 & test!=. & calpc>6000 & subgroup!=14
gen check=1
keep hhid itc check calpc test quantpc medquantpc
sort hhid itc
merge hhid itc using temp
tab _merge
drop _merge
egen max=max(foodexp) if check==1, by(hhid itc)
gen check1=1 if foodexp==max
count if check1==1

* we check whether there are problems with implicit prices
egen euvalue2=median(uvalue), by(unit itc)
gen test1=uvalue/euvalue2
count if test1>5 & test1!=. & check==1 & foodexp>200
replace correct=1 if test1>5 & test1!=. & check==1 & foodexp>200
replace foodexp1=quant1*euvalue2 if correct==1

count if correct==1
list hhid maa_q07 type itc unit quant1 foodexp foodexp1 test test1 uvalue euvalue2 if correct==1

* possible mistakes in values and quantities: there are more than two transactions of the same item and one of them singles out as very expensive
egen number=sum(check), by(hhid itc)
egen medval=median(value), by(hhid itc)
count if number>2 & value>5*medval & check==1 & (maa_q07==0 | maa_q07==.) & (mad_q04==. | mad_q04==0) & correct!=1
gen test4=1 if number>2 & value>5*medval & check==1 & (maa_q07==0 | maa_q07==.) & (mad_q04==. | mad_q04==0) & correct!=1

list hhid maa_q07 type itc unit quant1 foodexp test test1 uvalue euvalue1 euvalue2 if test4==1

replace foodexp1=medval if test4==1
replace correct=1 if test4==1

*** possible mistakes in the period of expenditure

* it is declared as a daily expenditure or 15 days, but the value of this transaction is abnormally high
* for the following items we have some maximum values:
* flour, veal, mutton, olive oil, cheese, butter, milk, honey, bread, white beans, natural yogurt, rice, macaroni, potatoes, coffee, sugar

count if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

gen test5=1 if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

count if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct!=1 & test5!=1 & test>=10 & foodexp>=1000
list hhid type itc unit quant1 foodexp test test1 quantpc if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct!=1 & test5!=1 & test>=10 & foodexp>=1000
replace test5=1 if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct!=1 & test>=10 & test5!=1 & foodexp>=1000 & itc!=28

* we replace these values with median per capita values multiplied by household size
replace foodexp1=(medquantpc*hhsize)*medprice if test5==1
replace correct=1 if test5==1
drop test5 test4

count if number==1 & ((maa_q07!=. & maa_q07>1) | (mad_q04!=. & mad_q04>1)) & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

gen test5=1 if number==1 & ((maa_q07!=. & maa_q07>1) | (mad_q04!=. & mad_q04>1)) & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

replace foodexp1=(medquantpc*hhsize)*medprice if test5==1
replace correct=1 if test5==1
drop test5

* non purchased values

count if number==1 & type==2 & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

gen test5=1 if number==1 & type==2 & check1==1 & correct!=1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

count if number==1 & type==2 & check1==1 & correct!=1 & foodexp>=1000 & test>10 & test5!=1
list hhid type itc unit quant1 foodexp test test1 quantpc if number==1 & type==2 & check1==1 & correct!=1 & test>=10 & foodexp>=1000 & test5!=1
replace test5=1 if number==1 & type==2 & check1==1 & correct!=1 & test>=10 & foodexp>=1000 & test5!=1

* we replace these values with median per capita values multiplied by household size
replace foodexp1=(medquantpc*hhsize)*medprice if test5==1
replace correct=1 if test5==1
drop test5


*** there are more than two purchases that should be consumed in the period of 15 days or more

gen one=1 if check==1 & ((maa_q07!=0 & maa_q07!=.) | mad_q04!=.) & correct!=1
sort hhid itc
egen sum=sum(one) if one==1, by(hhid itc)

count if sum>=2 & one==1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

gen test5=1 if sum>=2 & one==1 & /*
*/ ((itc==13 & quantpc>8) | (itc==27 & quantpc>2) | (itc==34 & quantpc>2) | (itc==85 & quantpc>1) | (itc==69 & quantpc>1) | (itc==76 & quantpc>1)  /*
*/  | (itc==65 & quantpc>14) | (itc==176 & quantpc>0.25) | (itc==1 & quantpc>7) | (itc==148 & quantpc>1) | (itc==74 & quantpc>3) | (itc==12 & quantpc>4) | /*
*/ (itc==15 & quantpc>4) | (itc==156 & quantpc>4) | (itc==217 & quantpc>100) | (itc==175 & quantpc>2))

count if sum>=2 & one==1 & test>=10 & test5!=1 & foodexp>=500
replace test5=1 if sum>=2 & one==1 & test>=10 & test5!=1 & foodexp>=500
count if test5==1
count if test5==1 & check1==1

replace foodexp1=0 if test5==1 & check1==1
replace correct=1 if test5==1 & check1==1

* number of corrections
count if correct==1

replace quant1=foodexp1/medprice if correct==1
replace foodexp1=foodexp if correct!=1
sum foodexp foodexp1, det
drop quantpc-check check1 test1 number-test5
drop if foodexp1==0
sort hhid itc
save results\food1, replace


*********************************************************************
***    we still check for very high values in critical items      ***
*********************************************************************

clear
set mem 50m

use results\food1, clear
egen totfood=sum(foodexp1), by(hhid)
egen itcfood=sum(foodexp1), by(hhid itc)
gen share=itcfood/totfood
gen quantpc=(itcfood/medprice)/hhsize
egen medquantpc=median(quantpc), by(urbrur itc)
gen test=quantpc/medquantpc
gen one=1
egen ntrans=sum(one), by(hhid itc)

* one person cannot consume more than 8kg of flour per 2 weeks
gen check=1 if itc==13 & quantpc>8
* one person cannot consume more than 2kg of veal per 2 weeks
replace check=1 if itc==27 & quantpc>2
* one person cannot consume more than 2kg of mutton per 2 weeks
replace check=1 if itc==34 & quantpc>2
* one person cannot consume more than 1 liter of oil per 2 weeks
replace check=1 if itc==85 & quantpc>1
* one person cannot consume more than 1 kg of cheese per 2 weeks
replace check=1 if itc==69 & quantpc>1
* one person cannot consume more than 1 kg of butter per 2 weeks
replace check=1 if itc==76 & quantpc>1
* one person cannot consume more than 14 liters of milk per 2 weeks
replace check=1 if itc==65 & quantpc>14
* one person cannot consume more than 0.25 kg of honey per 2 weeks
replace check=1 if itc==176 & quantpc>0.25
* one person cannot consume more than 7 pieces (kg) of bread per 2 weeks
replace check=1 if itc==1 & quantpc>7
* one person cannot consume more than 1 kg of white beans per 2 weeks
replace check=1 if itc==148 & quantpc>1
* one person cannot consume more than 3 kg of natural yogurt per 2 weeks
replace check=1 if itc==74 & quantpc>3
* one person cannot consume more than 4 kg of rice per 2 weeks
replace check=1 if itc==12 & quantpc>4
* one person cannot consume more than 4 kg of macaroni per 2 weeks
replace check=1 if itc==15 & quantpc>4
* one person cannot consume more than 4 kg of potatoes per 2 weeks
replace check=1 if itc==156 & quantpc>4
* one person cannot consume more than 100gr of coffee per 2 weeks
replace check=1 if itc==217 & quantpc>100
* one person cannot consume more than 2 kg of sugar per 2 weeks
replace check=1 if itc==175 & quantpc>2

drop one max

egen max=max(foodexp) if check==1, by(hhid itc)
gen check1=1 if foodexp==max
count if check1==1

* we check whether there are problems with implicit prices
drop uvalue
recode unit 1=2 if (hhid==17209 & itc==1) | (hhid==19603 & itc==69) | (hhid==30207 & itc==13) | (hhid==6903 & itc==217) | (hhid==23402 & itc==156) | (hhid==32703 & itc==1) | (hhid==44501 & itc==27)
drop euvalue2
gen uvalue=foodexp1/quant1
egen euvalue2=median(uvalue), by(unit itc)
gen test1=uvalue/euvalue2
count if test1>5 & test1!=. & check==1 & foodexp1>200
gen correct1=1 if test1>5 & test1!=. & check==1 & foodexp1>200
count if correct1==1
list hhid maa_q07 type itc unit quant1 foodexp foodexp1 test test1 uvalue euvalue2 if correct1==1
replace foodexp1=quant1*euvalue2 if correct1==1

* possible mistakes in values and quantities: there are more than two transactions of the same item and one of them singles out as very expensive
egen number=sum(check), by(hhid itc)
egen medval=median(foodexp1), by(hhid itc)
count if number>2 & foodexp1>5*medval & check==1 & (maa_q07==0 | maa_q07==.) & (mad_q04==. | mad_q04==0) & correct1!=1
gen test4=1 if number>2 & value>5*medval & check==1 & (maa_q07==0 | maa_q07==.) & (mad_q04==. | mad_q04==0) & correct1!=1

list hhid maa_q07 type itc unit quant1 foodexp test test1 uvalue euvalue1 euvalue2 if test4==1

replace foodexp1=medval if test4==1
replace correct1=1 if test4==1

*** possible mistakes in the period of expenditure

count if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct1!=1
gen test5=1 if number==1 & (maa_q07==0 | maa_q07==1 | mad_q04==1) & check1==1 & correct1!=1
count if number==1 & ((maa_q07!=. & maa_q07>1) | (mad_q04!=. & mad_q04>1)) & check1==1 & correct1!=1
replace test5=1 if number==1 & ((maa_q07!=. & maa_q07>1) | (mad_q04!=. & mad_q04>1)) & check1==1 & correct1!=1

* we replace these values with median per capita values multiplied by household size
replace foodexp1=(medquantpc*hhsize)*medprice if test5==1
replace correct1=1 if test5==1
drop test5 test4

* non purchased values

count if number==1 & type==2 & check1==1 & correct1!=1
gen test5=1 if number==1 & type==2 & check1==1 & correct1!=1

* we replace these values with median per capita values multiplied by household size
replace foodexp1=(medquantpc*hhsize)*medprice if test5==1
replace correct1=1 if test5==1
drop test5


*** there are more than two purchases that should be consumed in the period of 15 days or more

gen one=1 if check==1 & ((maa_q07!=0 & maa_q07!=.) | mad_q04!=.) & correct1!=1
sort hhid itc
egen sum=sum(one) if one==1, by(hhid itc)

count if sum>=2 & one==1
gen test5=1 if sum>=2 & one==1

count if test5==1 & check1==1
replace foodexp1=0 if test5==1 & check1==1
replace correct1=1 if test5==1 & check1==1

count if correct1==1
* number of corrections: 1082

replace quant1=foodexp1/medprice if correct1==1
sum foodexp foodexp1, det

drop quantpc-check1 test1-test5
drop if foodexp1==0
sort hhid itc
save results\food1, replace

*** Some more checks on unit values

use results\food1, clear
gen imprice=foodexp1/quant1
egen p0=median(imprice) if unit==umode, by(itc)
egen p0umode=median(p0), by(itc)
drop p0
drop medprice
egen medprice=median(imprice), by(itc unit)

gen quantx=(foodexp1/p0umode)/hhsize
egen quantpc=sum(quantx), by(hhid itc)
gen test=imprice/medprice

count if type==1 & test>=5 & foodexp1>300 & unit==umode
list hhid itc unit umode quant value quant1 foodexp1 maa_q07 imprice medprice p0umode test if type==1 & test>=5 & foodexp1>300 & unit==umode
* these are likely to be problems with old and new leks
replace quant1=quantx if type==1 & test>=5 & foodexp1>300 & unit==umode
replace foodexp1=quantx*p0 if type==1 & test>=5 & foodexp1>300 & unit==umode

count if type==1 & test>=5 & foodexp1>300 & unit!=umode
list hhid itc unit umode quant value quant1 foodexp1 maa_q07 imprice medprice p0umode test if type==1 & test>=5 & foodexp1>300 & unit!=umode

count if type==2 & test>=5 & foodexp1>300 & unit==umode
list hhid itc unit umode quant value quant1 quantx foodexp1 imprice medprice p0umode test if type==2 & test>=5 & foodexp1>300 & unit==umode
replace quant1=quantx if type==2 & test>=5 & foodexp1>300 & unit==umode
replace foodexp1=quantx*p0 if type==2 & test>=5 & foodexp1>300 & unit==umode

count if type==2 & test>=5 & foodexp1>300 & unit!=umode
list hhid itc unit umode quant value quant1 quantx foodexp1 imprice medprice p0umode test if type==2 & test>=5 & foodexp1>300 & unit!=umode

drop imprice-p0umode quantx-test
sort hhid itc
save results\food1, replace


*****************************************************************************************
*****                                                                               *****
*****       Now we can create consumption patterns and total food expenditure       *****
*****                                                                               *****
*****************************************************************************************


use results\food1, clear
collapse (mean) urbrur-weight (sum) foodexp=foodexp1, by(hhid subgroup)
local i = 1
while `i' <= 14 {
gen group`i'=foodexp if subgroup==`i'
local i = `i' + 1
}
collapse (mean) urbrur-weight (sum) group1-group14, by(hhid)
egen food=rsum(group1-group14)

local i = 1
while `i' <= 14 {
gen grsh`i'=group`i'/food
local i = `i' + 1
}

sort hhid
gen psu=int(hhid/100)
gen area=1 if psu>=376
replace area=2 if urbrur==1 & area==.
replace area=3 if urbrur==2
label val area area1
gen weight1=weight*food
replace food=food*2.17
save temp, replace

use results\hhroster, clear
gen hhsize=1
collapse (sum) hhsize, by(hhid)
sort hhid
save temp0, replace
use temp, clear
sort hhid
merge hhid using temp0
tab _merge
drop _merge

gen pcfood=food/hhsize
gen pweight=weight*hhsize

log using results\food.log, replace

table area [pw=weight], c(m food med food max food)

table area [pw=pweight], c(m pcfood med pcfood max pcfood)


*** Food consumption patterns

log off
collapse (mean) grsh1-grsh14 [aw=weight1], by(area)
xpose, clear
log on
list v1-v3
log off

use temp, clear
collapse (mean) grsh1-grsh14 [aw=weight1]
xpose, clear
log on
list v1
log off

use temp, clear
keep hhid-weight food psu area
sort hhid
save results\foodexp, replace

log on
*** Purchased and non purchased
log off

use results\food1, clear
recode type 0=1 3=1
replace type=3 if subgroup==14
collapse (mean) urbrur-weight (sum) foodexp=foodexp1, by(hhid type)

local i = 1
while `i' <= 3 {
gen group`i'=foodexp if type==`i'
local i = `i' + 1
}
collapse (mean) urbrur-weight (sum) group1-group3, by(hhid)
egen food=rsum(group1-group3)

local i = 1
while `i' <= 3 {
gen grsh`i'=group`i'/food
local i = `i' + 1
}

sort hhid
gen psu=int(hhid/100)
gen area=1 if psu>=376
replace area=2 if urbrur==1 & area==.
replace area=3 if urbrur==2
label val area area1
gen weight1=weight*food
save temp, replace

collapse (mean) grsh1-grsh3 [aw=weight1], by(area)
xpose, clear
log on
list v1-v3
log off

use temp, clear
collapse (mean) grsh1-grsh3 [aw=weight1]
xpose, clear
log on
list v1
log close

