clear
set mem 10m

*** 1. real per capita food and consumption

use results\poverty, clear
gen rpcfood=(food/hhsize)/psupind
table area [aw=pweight], c(m rpcfood m rpcons3) row


*** 2. Analysis of rents

use data\dwelling_cl, clear
sort hhid
merge hhid using results\poverty
tab _merge

recode m3a_q15 0=. 99997=. 99998=. 9999996=. 9999997=. 9999998=.
recode m3a_q17 9999997=. 9999998=.
gen arent=m3a_q17 if m3a_q17!=.
gen srent=m3a_q15 if m3a_q15!=. & m3a_q16==1
gen rrent=rent if arent==. & srent==.

table area [aw=weight], c(m arent med arent n arent) row
table area [aw=weight], c(m srent med srent n srent) row
table area [aw=weight], c(m rrent med rrent n rrent) row
table area [aw=weight], c(m rent med rent n rent) row



*** 3. Medicine discounts

clear
set mem 30m


use results\hhroster, clear

rename m5a_q19 medisc
rename m5a_q68 license
replace license=0 if  m5a_q67==2
label def M5A_Q68 0 "no license", add
lab val license M5A_Q68
tab license
count if medisc!=. & license==.

sort hhid
merge hhid using results\poverty
tab _merge

gen poor=100 if rpcons3<povline3
recode poor .=0

table medisc [aw=weight], c(m poor m rpcons3) row



*** 4. Food adequacy and food consumption

use data\subjpov_cl, clear
sort hhid
merge hhid using results\poverty
tab _merge
drop _merge

gen rfoodpc=(food/hhsize)/psupind

table m09_q06 [aw=pweight] if m09_q06<=3, c(m rfoodpc med rfoodpc min rfoodpc max rfoodpc n rfoodpc) row

table m09_q06 [aw=pweight], c(m rpcons3)

