*** Non food expenditure

clear
set mem 10m

use data\nonfoodexp_6m_cl, clear
recode mbb_q03 25800=2500 if hhid==44808 & mbb_q00==24
keep if mbb_q02==1
rename mbb_q00 code
tab code, nolab
gen nfood=mbb_q03/6
table code, c(m mbb_q03 med mbb_q03 min mbb_q03 max mbb_q03 n mbb_q03)
keep psu hhid code nfood
sort hhid code
save temp, replace

use data\nonfoodexp_12m_cl, clear
keep if mbc_q02==1
rename mbc_q00 code
tab code, nolab
drop if code==44 | code==47
gen nfood=mbc_q03/12
table code, c(m mbc_q03 med mbc_q03 min mbc_q03 max mbc_q03 n mbc_q03)
* we also drop some other items which are likely to be beyond the period considered
drop if code<=36 | code==48
keep psu hhid code nfood
sort hhid code
save temp1, replace

use data\nonfoodexp_1m_cl, clear
recode mba_q03 8020=8000 if hhid==30604 & mba_q00==1
recode mba_q03 25003=2500 if hhid==39403 & mba_q00==3
keep if mba_q02==1
rename mba_q00 code
tab code, nolab
gen nfood=mba_q03
table code, c(m mba_q03 med mba_q03 min mba_q03 max mba_q03 n mba_q03)
drop if code==15
keep psu hhid code nfood
sort hhid code
merge hhid code using temp
tab _merge
drop _merge
sort hhid code
merge hhid code using temp1
tab _merge
drop _merge

gen subgroup=1 if (code>=1 & code<=4) | code==6
replace subgroup=2 if code==7 | code==8 | code==41
replace subgroup=3 if code==11 | code==14 | (code>=29 & code<=31) | code==40
replace subgroup=4 if code==12 | code==13
replace subgroup=5 if code==5 | code==9 | code==32 | code==33
replace subgroup=6 if code>=16 & code<=23
replace subgroup=7 if code>=37 & code<=39
replace subgroup=8 if code>=24 & code<=28
replace subgroup=9 if code==45 | code==46
replace subgroup=10 if code==10 | code==42 | code==43

label def subgroup 1 "cleaning"
label def subgroup 2 "transport", add
label def subgroup 3 "hobby", add
label def subgroup 4 "alcohol", add
label def subgroup 5 "services", add
label def subgroup 6 "clothing", add
label def subgroup 7 "personal", add
label def subgroup 8 "houseart", add
label def subgroup 9 "cerimonies", add
label def subgroup 10 "other", add

sort hhid code
save results\nfood, replace

* this file will be used to check outliers with the "budget share method"
table code, c(m nfood max nfood n nfood)

collapse (sum) nfood, by(hhid subgroup)

gen sub1=nfood if subgroup==1
gen sub2=nfood if subgroup==2
gen sub3=nfood if subgroup==3
gen sub4=nfood if subgroup==4
gen sub5=nfood if subgroup==5
gen sub6=nfood if subgroup==6
gen sub7=nfood if subgroup==7
gen sub8=nfood if subgroup==8
gen sub9=nfood if subgroup==9
gen sub10=nfood if subgroup==10

collapse (sum) sub1-sub10, by(hhid)
sort hhid
save results\nfoodexp, replace

*** this file should be merged with the rest of consumption and shares and values should be checked


